// returns a phrase evaluating an individual exam or
// set of quizzes, based on category number
//
#include "mkevals.h"

string eval_item(uns cat_no, dbl score)
{
    switch(cat_no){
        case 0:  // "F"
            if (score == 0.0)               // assume no 0.0 for quizzes
                return "Apparently did not take this exam.\n";
            else
                return "Very weak.\n";
        case 1:  // "D"
            return "Weak.\n";
        case 2:  // "C-"
        case 3:  // "C"
            return "Adequate.\n";
        case 4:  // "B-"
        case 5:  // "B"
            return "Good, near the class median.\n";
        case 6:  // "B+"
            return "Very good, well above the class median score.\n";
        case 7:  // "A-"
        case 8:  // "A"
            return "Excellent, among the best in the class.\n";
        case 9:  // "A+"
            return "Outstanding, among the very top scores.\n";
        default:
            err("Unable to categorize this exam (from eval_item.c)");
                 // should not get here
    }
    return "";  // should not reach here
}
