// gets breakpoints and weights
// from input file
// and does general checking of item lines
//
#include "mkevals.h"

void get_template_data(misc* mp, matrix& bp,
        vector<dbl>& wt, char** argv)
{
    cstr digits = "0123456789";
    extern int optind;
    string line;
    string word;
    string midtag;                   // midterm tag
    no_yes finflag = no;             // see below for case 'f'
    mp->hmwk = no;
    mp->quizzes = no;
    mp->mids = 0;
    mp->items = 0;
    ifstream ifs(argv[optind]);      // open input file
    if (!ifs)                        // make sure input file exists
        err("could not find an input file called \"", argv[optind], "\"");

    for (int n = 1 ; getline(ifs, line) ; n++) {
        if (line.find("#") < string::npos)    // comment line has a "#"
            continue;                         // so bypass it
        if (line.find("@@@@") < string::npos) // first header line
            continue;                         // so bypass it
        if (line.find("&&&&") < string::npos) // first name header line
            break;                            // marks end of bp array
        if (countwords(line) != nbpts+2)      // check line length
            err("there should be ", nbpts+2, " \'entries\' in line ", n, " of your header table");
        switch(tolower(line[0])) {
            case 'f':  // final tag
                if (finflag)
                    err("found more than one \"final\" item "
                        "tag on line ", n);
                finflag = yes;
                mp->tag.push_back(FIN);
                get_bps_and_wt(line, bp, wt);
                break;
            case 'q':  // quizzes tag
                if (mp->quizzes)
                    err("found more than one \"quiz\" item "
                        "tag on line ", n);
                mp->quizzes = yes;
                mp->tag.push_back(QUIZ);
                get_bps_and_wt(line, bp, wt);
                break;
            case 'm':  // midterm tag
                mp->mids++;
                midtag = MID;                // base tag
                midtag += digits[mp->mids];  // add appropriate digit
                mp->tag.push_back(midtag);   // add to tag vector
                get_bps_and_wt(line, bp, wt);
                break;
            case 'h':
                if (mp->hmwk)
                    err("found more than one \"homework\" item "
                        "tag on line ", n);
                mp->tag.push_back(HMWK);
                get_bps_and_wt(line, bp, wt);
                mp->hmwk = yes;
//                mp->items++;
                break;
            default:
                err("found unrecognizable item tag in line ", n,
                        ".\n   (be sure not to indent these lines)...");
                break;
        }
    }
    mp->items = mp->tag.size();  // determine number of items
    ifs.close();
    return;
}
