// prints a brief "help file" on the screen
//

#include "mkevals.h"

void prn_info(char** argv)
{
    prn_usage(argv);

    cerr <<
        "   \033[1;32mmkevals\033[0;m will form written narrative evaluations using\n"
        "   as an input file the file provided by the registrar's office\n"
        "   that contains the list of students enrolled in the course.\n"
        "   This file must be suitably edited to provide the numerical\n"
        "   data to be used by \033[1;32mmkevals\033[0;m.  For additional details,\n"
        "   see the man page (\033[1;32mman mkevals\033[0;m), or other documentation\n"
        "   for the \033[1;32mmkevals\033[0;m program.\n\n";
#ifdef __GLIBC__
    cerr <<
        "  Options:\n\n"
        "     --help            display this help message\n"
        "     --version         print version number\n"
        "     --plus            allow \"+\" and \"-\" grades\n"
        "     --rank            provide a class ranking by category\n"
        "     --upgrade         discount low early exam scores\n"
        "     --old             accommodate old style class rosters\n"
        "     --debug           show detailed program operation\n\n";
    cerr <<
        "  Single-letter options (try \033[1;32m"
        << argv[0]
        << " -v\033[0;m) also exist.\n\n";
#else
    cerr <<
        "  Options:\n\n"
        "     -h         display this help message\n"
        "     -v         print version number\n"
        "     -p         (for \"plus\") allow \"+\" and \"-\" grades\n"
        "     -r         (for \"rank\") provide a class ranking by category\n"
        "     -u         (for \"upgrade\") discount low early exam scores\n"
        "     -o         (for \"old\") accommodate old style class rosters\n"
        "     -d         (for \"debug\") show detailed program operation\n\n";
#endif
}
