// upgrades to discount midterms whose categories
// are less than the final category
//
#include "mkevals.h"

void upgrade(misc* mp, matrix& bp, vector<dbl>& item,
        vector<dbl>& wt, vector<uns>& cat)
{
    vector<dbl> wt_save = wt;        // save weight vector
    matrix bp_save = bp;             // save bp array
// cout << "bp.size() = " << bp.size() << "\n";
    uns cattot_save = cat[mp->items];// save total category
    cat[mp->items] = 0;              // reset total category
    item[mp->items] = 0.0;           // reset total score
    vector<uns> indx = get_item_indices(mp);

    for (uns k = 1 ; k <= (mp->mids + mp->quizzes) ; ++k){
        if (cat[indx[k]] < cat[indx[0]])
            wt[indx[k]] = 0.0;       // discount low mid or quizzes
    }
    normalize_wts(mp, wt);           // renormalize new weights
    get_total(mp, item, wt);         // recalculate total score
    calc_tot_bps(bp, wt, mp->items); // recalculate bp[tot][k]
    findcats(bp, item, cat, 0, mp->items); // recategorize
//
//    the debug lines below allow the details of the scoring process
//    to be displayed.  these lines appear only with the
//    upgrade option.  see also show_details.c
//
    if (mp->debug){
        uns k;
        cout.setf(ios::fixed, ios::left);
        cout << " ";
        for (k = 0 ; k < mp->items ; k++){
            cout << setw(5) << setprecision(1) << item[k] << "("
                << setprecision(2) << wt[k] << ":" << cat[k]
                << ") ";
        }
        cout << setw(5) << setprecision(1) << item.back() << "(:"
            << cat.back() << ")\n";
        cout << " new total score bkpts:\n    ";
        cout.precision(2);
        for (k = 0 ; k < nbpts ; k++){
            cout << bp[mp->items][k] << "  ";
        }
        cout << "\n";
    }
    if (cat[mp->items] > cattot_save)// if total category increases,
        mp->upgradeflag = on;        // add phrase to evaluation
    wt = wt_save;                    // restore weight vector
    bp = bp_save;                    // restore bp array
}

